def foldr(func, init, seq):
    if not seq:
        return init
    else:
        return func(seq[0], foldr(func, init, seq[1:]))

result = foldr(lambda x, y: x * 2 + y, 0, [1, 2, 3, 4])
print(result)

def map(mapf, seq):
    if not seq:
        return []
    else:
        return [mapf(seq[0])] + map(mapf, seq[1:])

result = map(lambda x: x * 2, [1, 2, 3, 4])
print(result)

# map
result = foldr(lambda seqval, acc: [(lambda x: x * 2)(seqval)] + acc, [], [1, 2, 3, 4])
print(result)

# reverse
result = foldr(lambda seqval, acc: acc + [seqval], [], [1, 2, 3, 4])
print(result)

# clown shit
result = foldr(lambda seqval, acc: lambda x: seqval(acc(x)), lambda x: x, [lambda x: x + 1, lambda x: x * 7, lambda x: -x])
print(result)

result = foldr(lambda seqval, acc: lambda x: seqval(acc(x)), lambda x: x, [lambda x: x + 1, lambda x: x * 7, lambda x: -x])(8)
print(result)

# fails
result = foldr(lambda x, y: x * 10 + y, 0, [3, 4, 5, 6])
print(result)

def foldl(func, init, seq):
    if not seq:
        return init
    else:
        return foldl(func, func(init, seq[0]), seq[1:])

result = foldl(lambda x, y: x * 10 + y, 0, [3, 4, 5, 6])
print(result)

# gettin goofy
acc = 0
scanned = [acc := acc * 10 + x for x in [3, 4, 5, 6]]
print(scanned)
print(acc)

from functools import reduce
result = reduce(lambda x, y: x * 10 + y, [3, 4, 5, 6])
print(result)


